#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "maclist.h"
#include "data.h"
#include "loadconfig.h"
#include "log.h"

time_t lastlog;

void maclist_load(void){
	FILE *fp;	/* pointeur du fichier */
	char buf;	/* pointeur sur la ligne lue */
	unsigned char key[1024];
	int qui;
	int p;
	data_mac mac;

	/* ouvrir le fichier */
	fp = fopen(config[CF_MACLIST].valeur.string, "r");
	if(fp == NULL){
		logger(LOG_ERR, "Ne trouve pas le fichier contenant les adresses mac");
		exit(1);
	}
	qui = 1;
	p = 0;
	while((buf=fgetc(fp))!=EOF){		
		if(buf==' ' || buf=='\t'){
			qui=2;
			key[p]=0;
			continue;
		}
		if(buf=='\n'){
			qui=1;
			p=0;
			data_tohex(key, &mac);
			data_add(&mac);
			continue;
		}
		if(qui==1) key[p]=buf;
		p++;
	}
	fclose(fp);
}

void maclist_reload(void){
	if(time(NULL) - lastlog >= config[CF_TIMEOUT].valeur.integer){
		logger(LOG_DEBUG, "Reload maclist\n");
		data_reset();
		maclist_load();
		lastlog = time(NULL);
	}
}
