#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include "loadconfig.h"
#include "log.h"

void daemonize(void){
	int pid;
	int i;
	int fd;
	char str[12];
	
	pid = fork();
	if(pid < 0){
		logger(LOG_ERR, "fork 1 ne fonctionne pas");
	}
	if(pid > 0){
		exit(0);
	}

	setsid();

	pid = fork();
	if(pid < 0){
		logger(LOG_ERR, "fork 2 ne fonctionne pas");
	}
	if(pid > 0){
		exit(0);
	}

	/* Ferme les descripteur de fichiers */
	close(0);
	close(1);
	close(2);

	/* ouvre les sortie standard (descripteurs 0 1 2) sur /dev/null */
	i = open("/dev/null", O_RDWR);
	dup(i);
	dup(i);

	umask(0);
	chdir("/tmp");

	fd = open(config[CF_LOCKFILE].valeur.string, O_RDWR | O_CREAT, 0640);
	if(fd < 0){
		logger(LOG_ERR, "ne peut pas creer le fichier de lock");
		exit(1);
	}
	if(lockf(fd, F_TLOCK, 0)<0){
		logger(LOG_ERR, "le daemon existe deja");
		exit(1);
	}

	snprintf(str, 12, "%d\n", getpid());
	write(fd, str, strlen(str));
}
